/*        CALCULATION OF EMPIRICAL NORMALIZED DISTRIBUTIONS            */

/*Requires the macro
NDF
*/

/*Specify the pathways to the macros for your computer*/
%INCLUDE 'C:\Documents and Settings\madden.1\My Documents\temp\Workshop files\Macros\ndf.sas';

/*Data from a wheat variety trial in Ohio. 20 plants rated for powdery mildew.

variety=	code for four different wheat varieties
rating=		0-10 ordinal rating for wheat powdery mildew
*/

data a;
input variety rating @@;
datalines;
1	8	2	1	3	5	4	3
1	8	2	5	3	8	4	2
1	8	2	1	3	2	4	2
1	6	2	6	3	2	4	1
1	8	2	5	3	5	4	1
1	8	2	8	3	5	4	3
1	9	2	8	3	2	4	1
1	9	2	8	3	1	4	2
1	7	2	8	3	1	4	1
1	8	2	8	3	2	4	2
1	5	2	1	3	8	4	5
1	7	2	6	3	5	4	5
1	9	2	5	3	2	4	2
1	5	2	5	3	2	4	2
1	8	2	6	3	1	4	1
1	5	2	5	3	5	4	2
1	6	2	2	3	5	4	1
1	8	2	8	3	6	4	2
1	8	2	5	3	8	4	2
1	5	2	6	3	5	4	6
;

*--Use the simple macro to get different versions of distributions;
*--Specify a value for MINX that is smaller than the smallest X in dataset;

%NDF(data=a,x=rating,group=variety,minx=0, print=yes);
run;
proc sort data=a out=a;
by variety;
proc boxplot data=a;
plot rating*variety;
run;

proc rank data=a out=a;	*--Get ranks;
	var rating; ranks r;

data a; set a; 
	re = (r-0.5)/80;		*--This is a way to get estimated relative effect directly;

*--One way to print out relevant statistics;
*--Easier to use Proc Tabulate (to be explained in later examples;
proc means data=a median mean;
class variety; var rating r re ;


run;

