/*         2-WAY FACTORIAL REPEATED MEASURES        */

/*Requires the macros
F2_LD_F1
LD_CI
*/

/*Specify the pathways to the macros for your computer*/
%INCLUDE 'C:\Documents and Settings\Denis Shah\My Documents\Nonparametrics\Macros\LD_CI.sas';
%INCLUDE 'C:\Documents and Settings\Denis Shah\My Documents\Nonparametrics\Macros\F2_LD_F1.sas';
/*This is used in the last section of the program for multiple comparisons*/
%INCLUDE 'C:\Documents and Settings\Denis Shah\My Documents\Nonparametrics\mult.sas';


/*Data courtesy of Jeff Stein, SDSU*/
options ls =100 ps= 1000 nodate nonumber;
/*
Experiment on Stewart's disease of sweet corn in response to corn variety and isolate of the 
bacterium Erwinia stewartii
variety = sweet corn variety: AMB BUCK JUB NAT
isol = bacterium isolate: 2-7
rep = replication: 1 2 3 4 
swr = disease rating 0-3 scale on day 48 72 96 120 days after inoculation
*/

/*original dataset*/
data sw;
input variety $ isol rep swr48 swr72 swr96 swr120;
group = right(variety)||"_"||left(put(isol,2.)); *<--Combination of variety and isol;
sub1 = _n_; *<--Unique label for every inoc x fert x rep combination;
cards;
AMB	2	1	0	1	1	1
AMB	2	2	1	1	1	2
AMB	2	3	0	1	1	1
AMB	2	4	1	2	1	2
AMB	3	1	0	1	1	2
AMB	3	2	0	1	2	3
AMB	3	3	1	2	2	3
AMB	3	4	0	1	2	3
AMB	4	1	1	2	2	3
AMB	4	2	1	2	2	3
AMB	4	3	0	1	2	3
AMB	4	4	0	1	1	2
AMB	5	1	0	1	2	3
AMB	5	2	0	1	1	2
AMB	5	3	0	1	1	2
AMB	5	4	0	1	2	2
AMB	6	1	0	1	2	2
AMB	6	2	1	2	2	3
AMB	6	3	0	1	2	2
AMB	6	4	0	1	2	2
AMB	7	1	0	1	2	2
AMB	7	2	1	2	3	3
AMB	7	3	0	1	2	3
AMB	7	4	0	1	2	3
BUCK	2	1	0	0	1	1
BUCK	2	2	0	0	1	1
BUCK	2	3	0	1	1	1
BUCK	2	4	0	1	1	1
BUCK	3	1	0	1	2	2
BUCK	3	2	1	2	3	3
BUCK	3	3	0	1	1	1
BUCK	3	4	0	1	2	3
BUCK	4	1	0	1	1	2
BUCK	4	2	0	1	2	3
BUCK	4	3	0	1	2	3
BUCK	4	4	1	2	2	3
BUCK	5	1	0	1	1	1
BUCK	5	2	0	1	1	2
BUCK	5	3	0	0	2	2
BUCK	5	4	0	1	1	1
BUCK	6	1	0	1	1	2
BUCK	6	2	0	0	1	1
BUCK	6	3	0	0	1	1
BUCK	6	4	1	2	1	2
BUCK	7	1	1	2	2	2
BUCK	7	2	0	1	2	3
BUCK	7	3	0	1	2	2
BUCK	7	4	0	1	1	2
JUB	2	1	0	1	2	3
JUB	2	2	0	1	2	2
JUB	2	3	0	1	2	3
JUB	2	4	1	2	2	3
JUB	3	1	1	2	2	3
JUB	3	2	1	2	3	3
JUB	3	3	1	2	3	3
JUB	3	4	0	1	2	3
JUB	4	1	0	1	2	3
JUB	4	2	0	1	2	3
JUB	4	3	1	2	3	3
JUB	4	4	0	1	2	3
JUB	5	1	0	0	0	0
JUB	5	2	0	1	2	3
JUB	5	3	1	2	3	3
JUB	5	4	0	1	1	2
JUB	6	1	0	1	2	3
JUB	6	2	1	2	3	3
JUB	6	3	0	1	2	3
JUB	6	4	1	2	3	3
JUB	7	1	0	1	2	3
JUB	7	2	1	2	3	3
JUB	7	3	1	2	3	3
JUB	7	4	0	1	2	3
NAT	2	1	0	1	1	1
NAT	2	2	0	1	1	2
NAT	2	3	0	1	1	1
NAT	2	4	0	1	1	1
NAT	3	1	0	1	2	3
NAT	3	2	1	2	2	3
NAT	3	3	0	1	2	3
NAT	3	4	0	1	2	2
NAT	4	1	0	1	2	2
NAT	4	2	1	2	2	3
NAT	4	3	0	1	2	2
NAT	4	4	0	1	2	3
NAT	5	1	1	2	2	3
NAT	5	2	0	1	2	2
NAT	5	3	0	1	2	2
NAT	5	4	0	0	1	1
NAT	6	1	0	1	2	2
NAT	6	2	0	1	2	3
NAT	6	3	0	1	1	1
NAT	6	4	0	1	1	2
NAT	7	1	0	1	2	3
NAT	7	2	1	2	3	3
NAT	7	3	0	0	1	1
NAT	7	4	1	2	2	3
;
run;
/*Check the dataset*/
title 'ORIGINAL DATA';
proc print data=sw;
run;


/*First, get the data in univariate format for analysis by macros and Proc Mixed*/
data sw2;
  set sw;
  t1=swr48;
  t2=swr72;
  t3=swr96;
  t4=swr120;
  array t{4} t1-t4; *<--Create an array;
  do i=1 to 4;
    if i=1 then time=48;
	if i=2 then time=72;
	if i=3 then time=96;
	if i=4 then time=120;
	swr=t{i};      *<--swr is the variable storing the rating values;
	output;
  end;
  drop i t1-t4 swr48 swr72 swr96 swr120; *<--No longer needed;
run;

/*Take a look at the data in univariate format*/
%macro skip;
title 'DATA IN UNIVARIATE FORMAT';
proc print data=sw2;
run;
%mend skip;

/*Summary of the median ratings*/
title 'MEDIAN RATINGS SUMMARY';
proc tabulate data=sw2 f=6.1;
  class variety isol time;
  var swr;
  table variety*isol, time*swr*(median); *<--Request median rating;
run;

title 'NONPARAMETRIC ANALYSIS WITH THE F2_LD_F1 MACRO';
%F2_LD_F1(data=sw2, var=swr, factor1=variety, factor2=isol, time=time, subject=sub1);
title 'RELATIVE TREATMENT EFFECTS';
%ld_ci(data=sw2, var=swr, group=group, time=time, subject=sub1);
title 'MARGINAL EFFECTS FOR VARIETY';
%ld_ci(data=sw2, var=swr, group=variety, time=time, subject=sub1);
title 'MARGINAL EFFECTS FOR ISOL';
%ld_ci(data=sw2, var=swr, group=isol, time=time, subject=sub1);


/*           NONPARAMETRIC ANALYSIS USING PROC MIXED        */
title 'ANALYSIS USING PROC MIXED';
/*First, obtain the ranks*/
proc rank data=sw2 out=sw2;
var swr;
ranks r;
run;
/*Sort by main factors, then time factor*/
proc sort data=sw2 out=sw2;
by sub1 time;
run;
proc mixed data=sw2 anovaf method=mivque0;
class variety isol time sub1;
model r = variety|isol|time /chisq;
repeated / type=un sub=sub1 group=variety*isol; *<--or group=group, same definition;
lsmeans variety*isol*time;
ods output lsmeans=c; *<--Output the lsmeans to dataset c;
run;


/*                 PLOTTING RELATIVE TREATMENT EFFECTS                */
/*One may want to visualize the relative treatment effects.
  Here we calculate the relative treatment effects from the lsmeans*/
data c2;
  set c;
  re = (Estimate-0.5)/384; *<-- re are the relative treatment effects;
  drop Effect DF tValue Probt; *<-- Just cleaning up a bit;
run;
title 'RELATIVE TREATMENT EFFECTS CALCULATED FROM PROC MIXED LSMEANS';
proc tabulate data=c2 f=6.2;
  class variety isol time;
  var re;
  table isol*variety, time*re*(mean); *<--Table of the relative effects;
run;

/*Now plot re*/
goptions reset=all;
symbol1 v=dot i=join;
title 'RELATIVE TREATMENT EFFECTS';
proc gplot data = c2;
  plot re*time = variety;
  plot re*time = isol;
run;
quit;

                                  /*NEW SECTION*/
/*The above analysis indicates a significant isolate by time interaction, which
one may wish to examine in more detail.  One can look at the isol*time relative effects*/
title 'EXAMINE THE ISOL*TIME INTERACTION';
proc mixed data=sw2 anovaf method=mivque0;
class variety isol time sub1;
model r = variety|isol|time /chisq;
repeated / type=un sub=sub1 group=variety*isol;
lsmeans isol*time;
ods output lsmeans=d;
run;

/*                 PLOTTING RELATIVE TREATMENT EFFECTS                */
data d2;
  set d;
  re = (Estimate-0.5)/384; *<-- re are the relative treatment effects;
  drop Effect DF tValue Probt; *<-- Just cleaning up a bit;
run;
title 'RELATIVE TREATMENT EFFECTS FOR ISOL*TIME';
proc tabulate data=d2 f=6.2;
  class isol time;
  var re;
  table isol, time*re*(mean);
run;

/*Now plot re*/
goptions reset=all;
symbol1 v=dot i=join;
title 'RELATIVE TREATMENT EFFECTS BY ISOLATE';
proc gplot data = d2;
  plot re*time = isol;
run;
quit;

%macro skip;
/*One may be interested in all pairwise comparisons between isolates.
This can be done by specifying contrasts.
An alternative is to use the mult macro, written by H.-P. Piepho,
which will produce letter-labelled groupings familiar in Proc GLM output.

NOTE:  use this as a rough estimate only!!
Standard errors produced by the pdiff option in Proc Mixed are not the same as the true standard
errors for the nonparametric analysis.  They may be close enough though to 
use the following as an approximation.  Can double-check with contrast statements.*/
title 'MULT COMPARISONS ON ISOL*TIME';
proc mixed data=sw2 anovaf method=mivque0;
  class variety isol time sub1;
  model r = variety|isol|time /chisq;
  repeated / type=un sub=sub1 group=variety*isol;
  lsmeans isol*time/pdiff;
  ods output diffs=diffs lsmeans=lsmeans;
  /*A few contrasts for comparison with the mult macro output*/
  contrast 'isol 2 vs 5 at time=120' isol 1 0 0 -1 0 0 
    isol*time 0 0 0 1  0 0 0 0  0 0 0 0  0 0 0 -1  0 0 0 0  0 0 0 0;
  contrast 'isol 2 vs 6 at time=120' isol 1 0 0 0 -1 0 
    isol*time 0 0 0 1  0 0 0 0  0 0 0 0  0 0 0 0  0 0 0 -1  0 0 0 0;
%mult(trt=isol, by=time, level=48);
%mult(trt=isol, by=time, level=72);
%mult(trt=isol, by=time, level=96);
%mult(trt=isol, by=time, level=120);
run;
%mend skip;








